"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var ban_1 = __importDefault(require("react-icons/lib/fa/ban"));
var check_circle_1 = __importDefault(require("react-icons/lib/fa/check-circle"));
var close_1 = __importDefault(require("react-icons/lib/fa/close"));
var exclamation_triangle_1 = __importDefault(require("react-icons/lib/fa/exclamation-triangle"));
var lightbulb_o_1 = __importDefault(require("react-icons/lib/fa/lightbulb-o"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var utils_1 = require("../../utils");
var Box_1 = require("../Box");
var Button_1 = __importDefault(require("../Button"));
var Flex_1 = require("../Flex");
var Txt_1 = __importDefault(require("../Txt"));
var getTitle = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return props.prefix;
    }
    return props.danger
        ? 'Oh snap!'
        : props.warning
            ? 'Warning!'
            : props.success
                ? 'Success!'
                : props.info
                    ? 'Note!'
                    : '';
};
var getIcon = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return;
    }
    return props.danger ? (React.createElement(ban_1.default, null)) : props.warning ? (React.createElement(exclamation_triangle_1.default, null)) : props.success ? (React.createElement(check_circle_1.default, null)) : props.info ? (React.createElement(lightbulb_o_1.default, null)) : ('');
};
var AlertIcon = styled_components_1.default(Txt_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tline-height: ", ";\n"], ["\n\tline-height: ", ";\n"])), function (props) { return utils_1.px(props.theme.fontSizes[2] * 1.5); });
var DismissButtonIcon = styled_components_1.default(AlertIcon)(templateObject_2 || (templateObject_2 = __makeTemplateObject([""], [""])));
var AlertTitle = styled_components_1.default(Txt_1.default.span)(templateObject_3 || (templateObject_3 = __makeTemplateObject([""], [""])));
var AlertBase = styled_components_1.default(Flex_1.Flex)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tjustify-content: space-between;\n\tmargin: 0;\n\tborder: 1px solid ", ";\n\tmin-height: ", ";\n\tpadding: ", ";\n\tborder-radius: ", ";\n\tfont-size: ", ";\n"], ["\n\tjustify-content: space-between;\n\tmargin: 0;\n\tborder: 1px solid ", ";\n\tmin-height: ", ";\n\tpadding: ",
    ";\n\tborder-radius: ", ";\n\tfont-size: ", ";\n"])), function (props) { return utils_1.getColor(props, 'bg', 'main'); }, function (props) { return utils_1.px(props.theme.space[4]); }, function (props) {
    return utils_1.px(props.theme.space[2]) + " " + utils_1.px(props.theme.space[3]);
}, function (props) { return utils_1.px(props.theme.radius); }, function (props) { return utils_1.px(props.theme.fontSizes[2]); });
var Outline = styled_components_1.default(AlertBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", ", & ", " {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", ", & ", " {\n\t\tcolor: ", ";\n\t}\n"])), function (props) { return props.bg || utils_1.getColor(props, 'bg', 'light'); }, function (props) { return props.theme.colors.text.main; }, AlertIcon, AlertTitle, DismissButtonIcon, function (props) { return utils_1.getColor(props, 'color', 'main'); });
var Filled = styled_components_1.default(AlertBase)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", " {\n\t\tcolor: #fff;\n\t}\n"], ["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", " {\n\t\tcolor: #fff;\n\t}\n"])), function (props) { return props.bg || utils_1.getColor(props, 'bg', 'main'); }, function (props) { return props.color || '#fff'; }, AlertTitle, DismissButtonIcon);
var Plaintext = styled_components_1.default(AlertBase)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\tmin-height: auto;\n\tpadding: 0;\n\tborder: 0;\n\n\t&,\n\t& ", " {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tmin-height: auto;\n\tpadding: 0;\n\tborder: 0;\n\n\t&,\n\t& ", " {\n\t\tcolor: ", ";\n\t}\n"])), DismissButtonIcon, function (props) { return props.color || utils_1.getColor(props, 'color', 'main'); });
var getWrapper = function (plaintext, emphasized) {
    if (plaintext) {
        return Plaintext;
    }
    if (emphasized) {
        return Filled;
    }
    return Outline;
};
var Alert = function (props) {
    var emphasized = props.emphasized, plaintext = props.plaintext, prefix = props.prefix, onDismiss = props.onDismiss, restProps = __rest(props, ["emphasized", "plaintext", "prefix", "onDismiss"]);
    var icon = getIcon(props);
    var iconMargin = plaintext ? 2 : 3;
    var title = plaintext ? null : getTitle(props);
    var Wrapper = getWrapper(plaintext, emphasized);
    return (React.createElement(Wrapper, __assign({ emphasized: emphasized }, restProps),
        icon && (React.createElement(AlertIcon, { plaintext: plaintext, mt: '-1px', mb: "auto", mr: iconMargin }, icon)),
        React.createElement(Box_1.Box, { flex: 1 },
            title && (React.createElement(AlertTitle, { fontSize: 2, bold: true, mr: 2 }, title)),
            props.children),
        onDismiss && (React.createElement(Button_1.default, { mt: '-1px', mb: "auto", ml: iconMargin, plain: true, onClick: onDismiss },
            React.createElement(DismissButtonIcon, { plaintext: plaintext },
                React.createElement(close_1.default, null))))));
};
exports.default = asRendition_1.default(Alert, [], ['bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
