import { __assign, __makeTemplateObject, __rest } from "tslib";
import * as React from 'react';
import FaBan from 'react-icons/lib/fa/ban';
import FaCheckCircle from 'react-icons/lib/fa/check-circle';
import FaClose from 'react-icons/lib/fa/close';
import FaExclamationTriangle from 'react-icons/lib/fa/exclamation-triangle';
import FaLightbulb from 'react-icons/lib/fa/lightbulb-o';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { getColor, px } from '../../utils';
import { Box } from '../Box';
import Button from '../Button';
import { Flex } from '../Flex';
import Txt from '../Txt';
var getTitle = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return props.prefix;
    }
    return props.danger
        ? 'Oh snap!'
        : props.warning
            ? 'Warning!'
            : props.success
                ? 'Success!'
                : props.info
                    ? 'Note!'
                    : '';
};
var getIcon = function (props) {
    if (props.prefix === false) {
        return;
    }
    if (props.prefix !== undefined) {
        return;
    }
    return props.danger ? (React.createElement(FaBan, null)) : props.warning ? (React.createElement(FaExclamationTriangle, null)) : props.success ? (React.createElement(FaCheckCircle, null)) : props.info ? (React.createElement(FaLightbulb, null)) : ('');
};
var AlertIcon = styled(Txt)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tline-height: ", ";\n"], ["\n\tline-height: ", ";\n"])), function (props) { return px(props.theme.fontSizes[2] * 1.5); });
var DismissButtonIcon = styled(AlertIcon)(templateObject_2 || (templateObject_2 = __makeTemplateObject([""], [""])));
var AlertTitle = styled(Txt.span)(templateObject_3 || (templateObject_3 = __makeTemplateObject([""], [""])));
var AlertBase = styled(Flex)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tjustify-content: space-between;\n\tmargin: 0;\n\tborder: 1px solid ", ";\n\tmin-height: ", ";\n\tpadding: ", ";\n\tborder-radius: ", ";\n\tfont-size: ", ";\n"], ["\n\tjustify-content: space-between;\n\tmargin: 0;\n\tborder: 1px solid ", ";\n\tmin-height: ", ";\n\tpadding: ",
    ";\n\tborder-radius: ", ";\n\tfont-size: ", ";\n"])), function (props) { return getColor(props, 'bg', 'main'); }, function (props) { return px(props.theme.space[4]); }, function (props) {
    return px(props.theme.space[2]) + " " + px(props.theme.space[3]);
}, function (props) { return px(props.theme.radius); }, function (props) { return px(props.theme.fontSizes[2]); });
var Outline = styled(AlertBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", ", & ", " {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", ", & ", " {\n\t\tcolor: ", ";\n\t}\n"])), function (props) { return props.bg || getColor(props, 'bg', 'light'); }, function (props) { return props.theme.colors.text.main; }, AlertIcon, AlertTitle, DismissButtonIcon, function (props) { return getColor(props, 'color', 'main'); });
var Filled = styled(AlertBase)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", " {\n\t\tcolor: #fff;\n\t}\n"], ["\n\tbackground: ", ";\n\tcolor: ", ";\n\n\t& ", ", & ", " {\n\t\tcolor: #fff;\n\t}\n"])), function (props) { return props.bg || getColor(props, 'bg', 'main'); }, function (props) { return props.color || '#fff'; }, AlertTitle, DismissButtonIcon);
var Plaintext = styled(AlertBase)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\tmin-height: auto;\n\tpadding: 0;\n\tborder: 0;\n\n\t&,\n\t& ", " {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tmin-height: auto;\n\tpadding: 0;\n\tborder: 0;\n\n\t&,\n\t& ", " {\n\t\tcolor: ", ";\n\t}\n"])), DismissButtonIcon, function (props) { return props.color || getColor(props, 'color', 'main'); });
var getWrapper = function (plaintext, emphasized) {
    if (plaintext) {
        return Plaintext;
    }
    if (emphasized) {
        return Filled;
    }
    return Outline;
};
var Alert = function (props) {
    var emphasized = props.emphasized, plaintext = props.plaintext, prefix = props.prefix, onDismiss = props.onDismiss, restProps = __rest(props, ["emphasized", "plaintext", "prefix", "onDismiss"]);
    var icon = getIcon(props);
    var iconMargin = plaintext ? 2 : 3;
    var title = plaintext ? null : getTitle(props);
    var Wrapper = getWrapper(plaintext, emphasized);
    return (React.createElement(Wrapper, __assign({ emphasized: emphasized }, restProps),
        icon && (React.createElement(AlertIcon, { plaintext: plaintext, mt: '-1px', mb: "auto", mr: iconMargin }, icon)),
        React.createElement(Box, { flex: 1 },
            title && (React.createElement(AlertTitle, { fontSize: 2, bold: true, mr: 2 }, title)),
            props.children),
        onDismiss && (React.createElement(Button, { mt: '-1px', mb: "auto", ml: iconMargin, plain: true, onClick: onDismiss },
            React.createElement(DismissButtonIcon, { plaintext: plaintext },
                React.createElement(FaClose, null))))));
};
export default asRendition(Alert, [], ['bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
